<?php

require_once 'warp/warplib/applet.inc';
require_once 'warp/conf/twitter/twitter.conf';

class Warp_Twitter_Applet extends Warp_Applet
{
    function Warp_Twitter_Applet($caption = "Twitter")
    {
        parent::__construct($caption);
    }

    function getDirectory()
    {
        return "twitter";
    }

    function renderPanel(&$appMan)
    {
       $twit = $this->getTwitters();
       if ($twit[0] == "<") {
          $twitters = new SimpleXMLElement($twit);
          $panel = "<b>".$twitters->status[0]->text."</b><br/>";
          $panel.= "<i>".$twitters->status[0]->user->name."</i>";
       } else {
          $panel = $twit;
       }

       return $panel;
    }

    function renderWindow(&$appMan)
    {
       $twit = $this->getTwitters();
       if ($twit[0] == "<") {
          $twitters = new SimpleXMLElement($twit);
          foreach ($twitters->status as $twit) {
             $html .= "<p><b><font size=+1>".$twit->text."</font></b>&nbsp;<i><br/>";
             $html .= $twit->user->name."</i><br/>";
          }
       } else {
          $html = $twit;
       }
       return $html;
    }

    function getTwitters() {
        $target = "http://twitter.com/statuses/friends_timeline.xml";

        $login = Warp_Twitter_Config::getUserName();
        $login.= ":";
        $login.= Warp_Twitter_Config::getPassword();

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $target);
        curl_setopt($ch, CURLOPT_USERPWD, $login);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        
        return curl_exec($ch);
     }

    function renderInfo(&$app_man, $fast=false)
    {
        if ($fast) {
            return "-";
        }

        return <<<EOD
<p>This simply reports the basic information from the friends_timeline of
your Twitter account. Add the username and password to the config script,
and away you go.
<p>To use the <i>Bearskin</i> tool, <tt>twit</tt>, which updates your twitter
status, modify the you will need to add your login credentials to the script.
<p><i>Dependencies: </i>curl</p>

EOD;
    }


}

?>

